// SSAO: depth-to-viewspace-position pixel shader

//#include "../../ShaderModelAutoGen.hlsl"
#include "shaders/common/bge.hlsl"
#include "./../postFx.hlsl"

uniform_sampler2D( prepassMap, 0 );

uniform float2 nearFar;


float4 main(PFXVertToPix IN) : SV_TARGET
{
   float4 prepass = prepassUncondition(prepassMap, IN.uv0);
   float depth = prepass.a;
   
   // Interpolated ray pointing to far plane in view space
   float3 frustumRayVS = normalize(IN.wsEyeRay);
   
   return float4(nearFar.y * depth * frustumRayVS, 1.0);
}